#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <locale.h>

int
main(int argc, char *argv[])
{
	setlocale(LC_ALL,"");
	char outstr[200];
	char *format;
	format="%a %b %e %X %Z %Y";

	char line[255];
	FILE *fp;

	time_t t;
	t = time(NULL);

	struct tm *tmp;
	struct stat pmt;
	tmp = localtime(&t);

	if (tmp == NULL) {
		perror ("localtime");
		exit(EXIT_FAILURE);
	}

	int opt,bydefault,buflen;
	long date;

	bydefault = 1;
	opterr = 0;

	while ((opt = getopt(argc, argv, "Rurfds")) != -1) {
		switch (opt) {

		case 'R':
			bydefault = 0;
			format = "%a, %d %b %X %Y %z";
			break;

		case 'u':
			bydefault = 0;
			tmp = gmtime(&t);

			if (tmp == NULL) {
				perror("gmtime");
				exit(EXIT_FAILURE);
			}
			format = "%a %b %e %X %Z %Y";
			break;

		case 'r':
			bydefault = 0;

			if (argc == 2) {
				fprintf(stderr,"date2: ключ должен использоваться с аргументом -- \"r\"\n");
				exit(EXIT_FAILURE);
			} else {
				stat(argv[2], &pmt);
				tmp = localtime(&pmt.st_ctime);
				format = "%a %b %e %X %Z %Y";

				++optind;
				if (argc > 3)
					if (*argv[optind] == '+') {
						format = ++argv[optind];
					}
			}

				break;

		case 'f':
			bydefault = 0;

			if (argc == 2) {
				fprintf(stderr,"date2: ключ должен использоваться с аргументом -- \"f\"\n");
				exit(EXIT_FAILURE);
			} else {

				if ((fp = fopen(argv[optind],"rt")) == NULL) {
					fprintf(stderr, "Не могу открыть файл \n");
					exit (EXIT_FAILURE );
				} else {

					while (fgets(line, 255, fp) != NULL) {
						strptime(line, "%Y-%m-%d %H:%M:%S", tmp);
						strftime(outstr, sizeof(outstr), format, tmp);
						printf("%s\n", outstr);
					}
				}
				exit(EXIT_FAILURE);
			}

				
		case 'd':
			bydefault = 0;

			if (argc == 2) {
				fprintf(stderr,"date2: ключ должен использоваться с аргументом -- \"d\"\n");
				exit(EXIT_FAILURE);
			} else {
				strptime(argv[optind], "%Y-%m-%d %H:%M:%S", tmp);
			}

			break;

		case 's':
			bydefault = 0;

			if (argc == 2) {
				fprintf(stderr,"date2: ключ должен использоваться с аргументом -- \"s\"\n");
				exit(EXIT_FAILURE);
			} else {
				strptime(argv[optind], "%Y-%m-%d %H:%M:%S", tmp);
				strftime(outstr, 200, "%s", tmp);
				date = atol(outstr);
				if (stime(&date) == -1 ) {
					printf("%s\n","Невозможно установить время");
				};
			}

			break;


		default:
			fprintf(stderr,"date2: неверный ключ -%s \n", argv[--optind]);
			exit(EXIT_FAILURE);
			break;
		}
	}

	if (bydefault == 1 && argc > 1) {
		if (*argv[optind] == '+') {
			format = ++argv[optind];
		} else {
			strptime(argv[optind], "%m%d%H%M%Y.%S", tmp);
			strftime(outstr, 200, "%s", tmp);
			date = atol(outstr);
			if (stime(&date) == -1) {
				printf("%s\n","Невозможно установить время");
			};
		}
	}

	strftime(outstr, 200, format, tmp);
	printf("%s\n",outstr);

	exit(EXIT_SUCCESS);
}



